%global __provides_exclude_from ^%{python3_sitearch}/.*\\.so$
%global pypi_name gevent
%global optflags %(echo %{optflags} -I%{_includedir}/libev)

Summary:       A coroutine-based Python networking library
Name:          python-%{pypi_name}
Version:       22.10.2
Release:       2%{?dist}
License:       MIT
URL:           http://www.gevent.org/
Source0:       %{pypi_source}

BuildRequires: gcc c-ares-devel libev-devel libuv-devel

%description
gevent is a coroutine -based Python networking library that uses greenlet to provide a high-level synchronous API on top of the libev or libuv event loop.

Features include:

- Fast event loop based on libev or libuv.
- Lightweight execution units based on greenlets.
- API that re-uses concepts from the Python standard library (for examples there are events and queues).
- Cooperative sockets with SSL support
- Cooperative DNS queries performed through a threadpool, dnspython, or c-ares.
- Monkey patching utility to get 3rd party modules to become cooperative
- TCP/UDP/HTTP servers
- Subprocess support (through gevent.subprocess)
- Thread pools

%package -n python3-%{pypi_name}
Summary:       %{summary}
BuildRequires: python3-devel python3-Cython python3-greenlet-devel >= 1.1.0 python3-setuptools
BuildRequires: python3-dns python3-psutil python3-zope-event python3-zope-interface

%description -n python3-%{pypi_name}
gevent is a coroutine -based Python networking library that uses greenlet to provide a high-level synchronous API on top of the libev or libuv event loop.

Features include:

- Fast event loop based on libev or libuv.
- Lightweight execution units based on greenlets.- API that re-uses concepts from the Python standard library (for examples there are events and queues).
- Cooperative sockets with SSL support
- Cooperative DNS queries performed through a threadpool, dnspython, or c-ares.
- Monkey patching utility to get 3rd party modules to become cooperative
- TCP/UDP/HTTP servers
- Subprocess support (through gevent.subprocess)
- Thread pools

%prep
%autosetup -n %{pypi_name}-%{version}

rm -r deps

rm $(grep -rl '/\* Generated by Cython')
rm src/gevent/_generated_include/*

%build
export GEVENTSETUP_EMBED=0
%py3_build

%install
export GEVENTSETUP_EMBED=0
%py3_install
rm %{buildroot}%{python3_sitearch}/%{pypi_name}/_*2.py
rm %{buildroot}%{python3_sitearch}/%{pypi_name}/__pycache__/_*2.*
find %{buildroot} -name '.buildinfo' -delete
find %{buildroot} -name '*.so' -exec chmod 755 {} ';'

%check
export PYTHONPATH=%{buildroot}%{python3_sitearch}
%__python3 -m gevent.tests || :
cd src/gevent/tests && GEVENT_FILE=thread %__python3 -mgevent.tests test__*subprocess*.py

%files -n python3-%{pypi_name}
%license LICENSE
%doc README.rst
%{python3_sitearch}/%{pypi_name}*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.10.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 11 2023 cunshunxia <cunshunxia@tencent.com> - 22.10.2-1
- initial build
